#!/usr/bin/python
'''Helper program to add bots for phpBB3.
Version 0.0.1
Feb 24 2008
Updated Feb 24 2008'''

from settings import table_prefix
from time import time

# bots data, ripped off phpBB3/install/install_install.php
botdata='''		'AdsBot [Google]'			=> array('AdsBot-Google', ''),
		'Alexa [Bot]'				=> array('ia_archiver', ''),
		'Alta Vista [Bot]'			=> array('Scooter/', ''),
		'Ask Jeeves [Bot]'			=> array('Ask Jeeves', ''),
		'Baidu [Spider]'			=> array('Baiduspider+(', ''),
		'Exabot [Bot]'				=> array('Exabot/', ''),
		'FAST Enterprise [Crawler]'	=> array('FAST Enterprise Crawler', ''),
		'FAST WebCrawler [Crawler]'	=> array('FAST-WebCrawler/', ''),
		'Francis [Bot]'				=> array('http://www.neomo.de/', ''),
		'Gigabot [Bot]'				=> array('Gigabot/', ''),
		'Google Adsense [Bot]'		=> array('Mediapartners-Google', ''),
		'Google Desktop'			=> array('Google Desktop', ''),
		'Google Feedfetcher'		=> array('Feedfetcher-Google', ''),
		'Google [Bot]'				=> array('Googlebot', ''),
		'Heise IT-Markt [Crawler]'	=> array('heise-IT-Markt-Crawler', ''),
		'Heritrix [Crawler]'		=> array('heritrix/1.', ''),
		'IBM Research [Bot]'		=> array('ibm.com/cs/crawler', ''),
		'ICCrawler - ICjobs'		=> array('ICCrawler - ICjobs', ''),
		'ichiro [Crawler]'			=> array('ichiro/2', ''),
		'Majestic-12 [Bot]'			=> array('MJ12bot/', ''),
		'Metager [Bot]'				=> array('MetagerBot/', ''),
		'MSN NewsBlogs'				=> array('msnbot-NewsBlogs/', ''),
		'MSN [Bot]'					=> array('msnbot/', ''),
		'MSNbot Media'				=> array('msnbot-media/', ''),
		'NG-Search [Bot]'			=> array('NG-Search/', ''),
		'Nutch [Bot]'				=> array('http://lucene.apache.org/nutch/', ''),
		'Nutch/CVS [Bot]'			=> array('NutchCVS/', ''),
		'OmniExplorer [Bot]'		=> array('OmniExplorer_Bot/', ''),
		'Online link [Validator]'	=> array('online link validator', ''),
		'psbot [Picsearch]'			=> array('psbot/0', ''),
		'Seekport [Bot]'			=> array('Seekbot/', ''),
		'Sensis [Crawler]'			=> array('Sensis Web Crawler', ''),
		'SEO Crawler'				=> array('SEO search Crawler/', ''),
		'Seoma [Crawler]'			=> array('Seoma [SEO Crawler]', ''),
		'SEOSearch [Crawler]'		=> array('SEOsearch/', ''),
		'Snappy [Bot]'				=> array('Snappy/1.1 ( http://www.urltrends.com/ )', ''),
		'Steeler [Crawler]'			=> array('http://www.tkl.iis.u-tokyo.ac.jp/~crawler/', ''),
		'Synoo [Bot]'				=> array('SynooBot/', ''),
		'Telekom [Bot]'				=> array('crawleradmin.t-info@telekom.de', ''),
		'TurnitinBot [Bot]'			=> array('TurnitinBot/', ''),
		'Voyager [Bot]'				=> array('voyager/1.0', ''),
		'W3 [Sitesearch]'			=> array('W3 SiteSearch Crawler', ''),
		'W3C [Linkcheck]'			=> array('W3C-checklink/', ''),
		'W3C [Validator]'			=> array('W3C_*Validator', ''),
		'WiseNut [Bot]'				=> array('http://www.WISEnutbot.com', ''),
		'YaCy [Bot]'				=> array('yacybot', ''),
		'Yahoo MMCrawler [Bot]'		=> array('Yahoo-MMCrawler/', ''),
		'Yahoo Slurp [Bot]'			=> array('Yahoo! DE Slurp', ''),
		'Yahoo [Bot]'				=> array('Yahoo! Slurp', ''),
		'YahooSeeker [Bot]'			=> array('YahooSeeker/', ''),'''

bot_list=[]
for line in botdata.split('\n'):
    name, arr=line.strip().strip(',').split('=>',1)
    bot_list.append((eval(name), eval(arr, {'array':lambda *args:args})))

try:
    f=open("pm_passwords.txt", "rt")
except IOError:
    print "Run this script *after* the members_topics_posts script."
    raw_input("Press <enter> to quit.")
    exit(1)
n=len(f.readlines())
f.close()
n+=2
out=open("bots_phpBB3.sql", "wt")
out.write("DELETE FROM "+table_prefix+'bots;\n')
for i, (bot_name, bot_ary) in enumerate(bot_list):
    out.write("INSERT INTO "+table_prefix+"users \
(user_id, user_type, group_id, username, username_clean, user_regdate, user_password, \
user_colour, user_email, user_email_hash, user_lang, user_style, user_timezone, user_dateformat, user_allow_massemail) VALUES ")
    out.write("(%i, 2, 6, '%s', '%s', %i, '', '9E8DA7', '', '00', 'english', 1, 0, 'D M d, Y g:i a', 0);\n"%(n+i, bot_name, bot_name.lower(), time()))
    out.write("INSERT INTO "+table_prefix+"user_group (group_id, user_id, user_pending, group_leader) VALUES (6, %i, 0, 0);\n"%(n+i))
    out.write("INSERT INTO "+table_prefix+"bots (bot_active, bot_name, user_id, bot_agent, bot_ip) VALUES (1, '%s', %i, '%s', '%s');\n"%(bot_name, n+i, bot_ary[0], bot_ary[1]))
out.close()
raw_input("Finished. Press <enter> to quit.")
